import { BuiltinPlugin } from "@rspack/binding";
import { BuiltinPluginName, RspackBuiltinPlugin } from "../builtin-plugin/base";
import { Compiler } from "../Compiler";
export type ProvideSharedPluginOptions = {
    provides: Provides;
    shareScope?: string;
};
export type Provides = (ProvidesItem | ProvidesObject)[] | ProvidesObject;
export type ProvidesItem = string;
export type ProvidesObject = {
    [k: string]: ProvidesConfig | ProvidesItem;
};
export type ProvidesConfig = {
    eager?: boolean;
    shareKey: string;
    shareScope?: string;
    version?: false | string;
};
export declare class ProvideSharedPlugin extends RspackBuiltinPlugin {
    name: BuiltinPluginName;
    _provides: [string, {
        shareKey: string;
        version: string | false | undefined;
        shareScope: string;
        eager: boolean;
    }][];
    constructor(options: ProvideSharedPluginOptions);
    raw(compiler: Compiler): BuiltinPlugin;
}
